package com.persagy.apm.energyalarmstarter.alarmdata.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

/**
 * 报警处理方式
 *
 * @author lixing
 * @version V1.0 2021/9/20 11:08 上午
 **/
@AllArgsConstructor
public enum EnumAlarmTreatMode {
    /**
     * 报警处理方式
     */
    IGNORE(1, "忽略"),
    ORDER(2, "转工单"),
    CLOSE(3, "关闭"),
    CONDITION_CHANGE(4, "变更条件关闭"),
    BLOCK_OBJ(5, "屏蔽关闭");

    @Setter
    @Getter
    private int type;

    @Setter
    private String desc;

    public String getDesc() {
        // 忽略和关闭在返回给前端时，返回屏蔽关闭
        if (this.equals(EnumAlarmTreatMode.IGNORE) || this.equals(EnumAlarmTreatMode.CLOSE)) {
            return BLOCK_OBJ.desc;
        } else {
            return desc;
        }
    }

    /**
     * 根据type获取到枚举对象
     *
     * @param type 枚举type值
     * @return 枚举对象
     * @author lixing
     * @version V1.0 2021/5/31 4:06 下午
     */
    public static EnumAlarmTreatMode getByType(int type) {
        EnumAlarmTreatMode[] enums = EnumAlarmTreatMode.values();
        for (EnumAlarmTreatMode item : enums) {
            if (type == item.getType()) {
                return item;
            }
        }
        return null;
    }
}
